#
# Copyright (C)2022..2023 @BABOLO http://www.babolo.ru/
# pkg = lrwi-textcase
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: text.pleaf.m4,v 1.8 2023/01/28 01:14:02 babolo Exp $
#
# 

eval
#perform 0002
CREATE TEMP TABLE SQNM(p)
     ( SQAT(i) int
     , SQAT(n) text
     , SQAT(p) text
     ) STRICT
;
#getpost _
#copyin  00_2
COPY SQNM(p) FROM stdin;
#wait
#close   _0_00_
#select  1002  #########################################################       ####
SELECT SQNM(text).SQAT(text) AS text, SQNM(text).SQAT(parm) AS parm
 FROM SQNM(x) JOIN SQNM(text) ON(SQNM(x).SQAT(m) == SQNM(text).SQAT(text))
;
#select  _012  #######################################################################    ####
SELECT SQNM(text).SQAT(head)     AS head
     , SQNM(text).SQAT(sub)      AS sub
     , SQNM(fullattr).SQAT(attr) AS attr
 FROM SQNM(text) LEFT JOIN SQNM(fullattr) USING(SQAT(text))
 WHERE SQNM(text).SQAT(text) == ?1
;
#style   00y00_
text
#display 00_00_
#close   _0_00_
#perform 0002
CREATE TEMP TABLE SQNM(pamparam)
     ( SQAT(ques) int
     , SQAT(poin) int
     , SQAT(answ) text
     , PRIMARY KEY(SQAT(ques), SQAT(poin))
     ) STRICT
;
#perform 0002
INSERT OR IGNORE INTO SQNM(pamparam)
 WITH b AS(SELECT SQNM(p).SQAT(n)                                    AS SQAT(n)
                , SQNM(p).SQAT(p)                                    AS SQAT(p)
                , CASE WHEN regexp('^[0-9]+_[0-9]+$', SQNM(p).SQAT(n))
                       THEN instr(SQNM(p).SQAT(n), '_')
                  END                                                AS SQAT(l)
            FROM SQNM(p)
          )
    , d AS(SELECT DISTINCT CAST(SQNM(p).SQAT(n) AS INTEGER) AS SQAT(ques)
            FROM SQNM(p)
            WHERE regexp('^[0-9]+$', SQNM(p).SQAT(n)) AND SQNM(p).SQAT(p) == 's'
          )
    , s AS(SELECT CAST(substring(b.SQAT(n), 1, b.SQAT(l) - 1) AS INTEGER) AS SQAT(ques)
                , CAST(substring(b.SQAT(n), b.SQAT(l) + 1) AS INTEGER)   AS SQAT(poin)
                , b.SQAT(p)                                             AS SQAT(answ)
            FROM b
            WHERE SQAT(l) IS NOT NULL
          )
 SELECT SQAT(ques), SQAT(poin), SQAT(answ) FROM d JOIN s USING(SQAT(ques))
;
#select  _012
SELECT SQNM(demo).SQAT(exec)
 FROM SQNM(text) JOIN SQNM(demo) USING(SQAT(demo))
 WHERE SQNM(text).SQAT(ordr) IS NOT NULL
   AND SQNM(text).SQAT(text) == ?1
;
#style   00y00d
form
#style   00y00h
hidd
#style   00y00o
ofrm
#style   00y00i
ifrm
#eval    0_
#close   _0_00_
#select  _01_
SELECT CINM(x).CIAT(sess)  AS sess
     , CINM(pnode).CIAT(p) AS page
     , ?                   AS text
     , ?                   AS parm
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(m) == 'BASE' AND CINM(pnode).CIAT(v) == 'oled'
;
#close   101
#select  10_2  ##########################################################################    ####
SELECT CASE WHEN SQNM(lede).SQAT(vizi) THEN ?1 END                    AS sess
     , CASE WHEN SQNM(lede).SQAT(vizi) THEN ?2 END                    AS page
     , SQNM(part).SQAT(name)                                          AS part
     , CASE WHEN SQNM(lede).SQAT(vizi) THEN SQNM(lede).SQAT(lede) END AS lede
     , SQNM(lede).SQAT(lf)                                            AS lf
     , SQNM(lede).SQAT(li)                                            AS li
     , SQNM(lede).SQAT(lo)                                            AS lo
     , CASE WHEN SQNM(lede).SQAT(vizi) THEN '' END                    AS vizi
 FROM SQNM(text)
  JOIN SQNM(textpart) USING(SQAT(text))
  JOIN SQNM(part) USING(SQAT(part))
  JOIN SQNM(lede) USING(SQAT(lede))
 WHERE SQNM(text).SQAT(text) == ?3
;
#style   00y00_
part
#display 00100_
#close   _0_00_
#close   101
